## netcdf-parallel 4.6.1

=== libdap2/CMakeLists.txt ===
SET(dap2_SOURCES constraints.c dapcvt.c dapodom.c daputil.c ncdaperr.c cdf.c cache.c dapdump.c dapdebug.c dapattr.c ncd2dispatch.c getvara.c dceconstraints.c dcetab.c dceparse.c dcelex.c)

add_library(dap2 OBJECT ${dap2_SOURCES})

###
# Options related to the man page generation.
###

###
# The C API man page.
###

set(man_MANS netcdf.3)

set(ARGS_MANPAGE -DAPI=C)

IF (USE_NETCDF4)
  SET(ARGS_MANPAGE ${ARGS_MANPAGE} -DNETCDF4=TRUE)
ENDIF(USE_NETCDF4)

IF (BUILD_DAP)
  SET(ARGS_MANPAGE ${ARGS_MANPAGE} -DDAP=TRUE)
ENDIF(BUILD_DAP)

IF (BUILD_PARALLEL)
  SET(ARGS_MANPAGE ${ARGS_MANPAGE} -DPARALLEL_IO=TRUE)
ENDIF(BUILD_PARALLEL)

FILE(GLOB CUR_EXTRA_DIST RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*.c ${CMAKE_CURRENT_SOURCE_DIR}/*.h)
SET(CUR_EXTRA_DIST ${CUR_EXTRA_DIST} dce.y CMakeLists.txt Makefile.am)
ADD_EXTRA_DIST("${CUR_EXTRA_DIST}")

=== libdap4/CMakeLists.txt ===
SET(dap4_SOURCES d4crc32.c d4curlfunctions.c d4curlflags.c d4fix.c d4data.c d4file.c d4parser.c d4meta.c d4varx.c d4dump.c d4swap.c d4chunk.c d4printer.c d4read.c d4http.c d4util.c d4odom.c d4cvt.c d4debug.c ncd4dispatch.c ezxml_extra.c ezxml.c)

add_library(dap4 OBJECT ${dap4_SOURCES})

###
# Options related to the man page generation.
###

###
# The C API man page.
###

set(man_MANS netcdf.3)

set(ARGS_MANPAGE -DAPI=C)

IF (USE_NETCDF4)
  SET(ARGS_MANPAGE ${ARGS_MANPAGE} -DNETCDF4=TRUE)
ENDIF(USE_NETCDF4)

IF (BUILD_DAP)
  SET(ARGS_MANPAGE ${ARGS_MANPAGE} -DDAP=TRUE)
ENDIF(BUILD_DAP)

IF (BUILD_PARALLEL)
  SET(ARGS_MANPAGE ${ARGS_MANPAGE} -DPARALLEL_IO=TRUE)
ENDIF(BUILD_PARALLEL)

FILE(GLOB CUR_EXTRA_DIST RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*.c ${CMAKE_CURRENT_SOURCE_DIR}/*.h)
SET(CUR_EXTRA_DIST ${CUR_EXTRA_DIST} dce.y CMakeLists.txt Makefile.am)
ADD_EXTRA_DIST("${CUR_EXTRA_DIST}")

=== libhdf4/CMakeLists.txt ===
## This is a CMake file, part of Unidata's netCDF package.
# Copyright 2018, see the COPYRIGHT file for more information.
#
# This builds the HDF4 dispatch layer.
#
# Ed Hartnett

# The source files for the HDF4 dispatch layer.
SET(libhdf4_SOURCES hdf4attr.c hdf4dim.c hdf4dispatch.c hdf4file.c hdf4func.c
  hdf4grp.c hdf4type.c hdf4var.c)

# Build the HDF4 dispatch layer as a library that will be included in
# the netCDF library.
add_library(netcdfhdf4 OBJECT ${libhdf4_SOURCES})

# Remember to package this file for CMake builds.
ADD_EXTRA_DIST(${libhdf4_SOURCES} CMakeLists.txt)

=== examples/C/hdf5plugins/CMakeLists.txt ===
SET(CMAKE_BUILD_TYPE "")

SET(libbzip2_SOURCES bzlib.h bzlib_private.h
         blocksort.c huffman.c crctable.c randtable.c compress.c decompress.c bzlib.c
         H5Zbzip2.c h5bzip2.h
)

# Get the compilable sources from nc_test4/hdf5plugins
FOREACH(S ${libbzip2_SOURCES})
  FILE(COPY ${CMAKE_SOURCE_DIR}/nc_test4/hdf5plugins/${S} DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})
ENDFOREACH(S)

IF(ENABLE_FILTER_TESTING)
IF(BUILD_UTILITIES)

# LDFLAGS = -module -avoid-version -shared -export-dynamic -no-undefined

ADD_LIBRARY(bzip2 MODULE ${libbzip2_SOURCES})
SET_TARGET_PROPERTIES(bzip2 PROPERTIES LIBRARY_OUTPUT_NAME "bzip2")
SET_TARGET_PROPERTIES(bzip2 PROPERTIES ARCHIVE_OUTPUT_NAME "bzip2")
SET_TARGET_PROPERTIES(bzip2 PROPERTIES RUNTIME_OUTPUT_NAME "bzip2")
TARGET_LINK_LIBRARIES(bzip2 ${HDF5_HL_LIBRARIES} ${HDF5_C_LIBRARIES})

ENDIF(BUILD_UTILITIES)
ENDIF(ENABLE_FILTER_TESTING)

# Copy some test files from current source dir to out-of-tree build dir.
FILE(COPY ${COPY_FILES} DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
IF(MSVC)
  FILE(COPY ${COPY_FILES} DESTINATION ${RUNTIME_OUTPUT_DIRECTORY}/)
ENDIF()

=== debian/changelog ===
netcdf-parallel (1:4.6.1-3) unstable; urgency=medium

  * Include netcdf_par.h in libnetcdf-mpi-dev.
  * Set binary and -dev packages as Multi-Arch: same

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 08 Nov 2018 14:38:52 +0000

netcdf-parallel (1:4.6.1-2) unstable; urgency=medium

  * Remove references to Debian GIS team, as this fork is purely maintained
    by me.
  * Push to separate repo on salsa, salsa.d.o/mckinstry/netcdf-parallel
  * Standards-Version now 4.2.1; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Nov 2018 06:24:26 +0000

netcdf-parallel (1:4.6.1-1) unstable; urgency=medium

  * Fork netcdf to create netcdf-parallel. Closes: #902976

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 04 Jul 2018 19:55:48 +0100

=== debian/control ===
Source: netcdf-parallel
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9.20160314),
               cmake (>= 3.6.1),
               chrpath,
               m4,
               doxygen,
               graphviz,
               libjs-jquery,
               libaec-dev,
               libhdf5-dev (>= 1.8.13+docs-1~),
 	       libhdf5-mpi-dev (>= 1.8.13+docs~),
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libpnetcdf-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/mckinstry/netcdf-parallel
Vcs-Git: https://salsa.debian.org/mckinstry/netcdf-parallel.git -b dev-coinstallable
Homepage: http://www.unidata.ucar.edu/software/netcdf/

Package: libnetcdf-mpi-13
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Interface for scientific data access to large binary data
 NetCDF (network Common Data Form) is an interface for scientific
 data access and a freely-distributed software library that provides an
 implementation of the interface.  The netCDF library also defines a
 machine-independent format for representing scientific data.
 Together, the interface, library, and format support the creation,
 access, and sharing of scientific data.
 .
 This package contains the C run-time shared libraries required
 by programs.

Package: libnetcdf-pnetcdf-13
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Interface for scientific data access to large binary data
 NetCDF (network Common Data Form) is an interface for scientific
 data access and a freely-distributed software library that provides an
 implementation of the interface.  The netCDF library also defines a
 machine-independent format for representing scientific data.
 Together, the interface, library, and format support the creation,
 access, and sharing of scientific data.
 .
 This package contains the C run-time shared libraries required
 by programs.

Package: libnetcdf-mpi-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnetcdf-mpi-13 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends},
         pkg-config
Suggests: netcdf-bin, netcdf-doc
Description: creation, access, and sharing of array-oriented scientific data
 NetCDF (network Common Data Form) is a set of interfaces for array-oriented
 data access and a freely distributed collection of data access libraries for
 C, Fortran, C++, Java, and other languages. The netCDF libraries support a
 machine-independent format for representing scientific data. Together, the
 interfaces, libraries, and format support the creation, access, and sharing of
 scientific data.
 .
 This package provides headers.

Package: libnetcdf-pnetcdf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnetcdf-pnetcdf-13 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends},
         pkg-config
Suggests: netcdf-bin, netcdf-doc
Description: creation, access, and sharing of array-oriented scientific data
 NetCDF (network Common Data Form) is a set of interfaces for array-oriented
 data access and a freely distributed collection of data access libraries for
 C, Fortran, C++, Java, and other languages. The netCDF libraries support a
 machine-independent format for representing scientific data. Together, the
 interfaces, libraries, and format support the creation, access, and sharing of
 scientific data.
 .
 This package provides headers.

=== debian/rules ===
#!/usr/bin/make -f

# Enable hardening build flags, except:
#  pie: causes build failure
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR:=/usr/include

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')
SO_MAJOR:=13
SO_VERSION:=13

include /usr/share/mpi-default-dev/debian_defaults
MPI:=$(ARCH_DEFAULT_MPI_IMPL)

include /usr/share/dpkg/pkg-info.mk


# Verbose test output
export VERBOSE=1
export DH_VERBOSE=1

CFLAGS:= $(shell dpkg-buildflags --get CFLAGS)

%:
	dh $@ --buildsystem=cmake

CMAKE_FLAGS:=   -DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_SKIP_RPATH:BOOL=ON \
		-DENABLE_TESTS:BOOL=ON \
		-DENABLE_DOXYGEN:BOOL=ON \
		-DENABLE_MMAP=ON \
		-DUSE_SZIP=ON 

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-pnetcdf -- \
		$(CMAKE_FLAGS) \
		-DHDF5_INCLUDE_PATH=$(INCDIR)/hdf5/serial \
		-DHDF5_LIBRARY_PATH=$(LIBDIR)//hdf5/serial \
		-DENABLE_PNETCDF=ON \
		-DPNETCDF_INCLUDE_DIR=/usr/include \
		-DLIBLIB_VERSION_SCRIPT=-Wl,--version-script,$(CURDIR)/debian/netcdf-pnetcdf.ver \
		-DCMAKE_C_COMPILER=mpicc  \
		-DNETCDF_LIB_NAME=netcdf_pnetcdf 
	dh_auto_configure --builddirectory=build-mpi --  \
		$(CMAKE_FLAGS) \
		-DENABLE_PARALLEL_TESTS:BOOL=OFF \
		-DUSE_HDF5=ON \
	        -DHDF5_INCLUDE_PATH=$(INCDIR)/hdf5/$(MPI) \
		-DHDF5_LIBRARY_PATH=$(LIBDIR)/hdf5/$(MPI) \
		-DHDF5_C_LIBRARIES=$(LIBDIR)/hdf5/$(MPI)/libhdf5.so \
		-DHDF5_HL_LIBRARIES=$(LIBDIR)/hdf5/$(MPI)/libhdf5_hl.so \
		-DCMAKE_C_FLAGS="${CFLAGS} -DHDF5_PARALLEL" \
		-DLIBLIB_VERSION_SCRIPT=-Wl,--version-script,$(CURDIR)/debian/netcdf-mpi.ver \
		-DCMAKE_C_COMPILER=mpicc  \
		-DNETCDF_LIB_NAME=netcdf_mpi

override_dh_auto_build:
	$(MAKE) -C build-pnetcdf
	$(MAKE) -C build-mpi

override_dh_auto_clean:
	rm -rf build-* debian/tmp* debian/*.postinst

override_dh_auto_install:
	for d in mpi pnetcdf ; do \
		$(MAKE) -C build-$$d install DESTDIR=$(CURDIR)/debian/tmp-$$d ; \
		mkdir -p debian/tmp/$(LIBDIR)/netcdf/$$d/cmake debian/tmp/$(LIBDIR)/cmake debian/tmp/$(LIBDIR)/pkgconfig ; \
		cp debian/tmp-$$d/$(LIBDIR)/libnetcdf.settings debian/tmp/$(LIBDIR)/netcdf/$$d/libnetcdf.settings ; \
		mkdir -p debian/tmp/$(LIBDIR)/netcdf/$$d/include ; \
		cp debian/tmp-$$d/usr/include/*	debian/tmp/$(LIBDIR)/netcdf/$$d/include ; \
		cp -a debian/tmp-$$d/$(LIBDIR)/cmake/netCDF	debian/tmp/$(LIBDIR)/cmake/netCDF_$$d ; \
		cp -a debian/tmp-$$d/$(LIBDIR)/libnetcdf_*.so* debian/tmp/$(LIBDIR) ; \
		dh_link -p libnetcdf-$$d-dev  $(LIBDIR)/cmake/netCDF_$$d $(LIBDIR)/netcdf/$$d/cmake/netCDF ; \
		cp debian/tmp-$$d/$(LIBDIR)/libnetcdf_$$d.so.$(SO_VERSION) debian/tmp/$(LIBDIR)/libnetcdf_$$d.so.$(SO_VERSION) ; \
		sed -e 's%@MULTIARCH@%$(DEB_HOST_MULTIARCH)%g' < debian/libnetcdf-$$d-dev.postinst.in \
			> debian/libnetcdf-$$d-dev.postinst ; \
		echo "prefix=$(LIBDIR)/netcdf/$$d" > debian/tmp/$(LIBDIR)/pkgconfig/netcdf-$$d.pc ; \
		sed -e 's/-lnetcdf/-lnetcdf_$$d/' < debian/tmp-$$d/$(LIBDIR)/pkgconfig/netcdf.pc \
			| grep -v "prefix=" \
			>> debian/tmp/$(LIBDIR)/pkgconfig/netcdf-$$d.pc ; \
		dh_link -p libnetcdf-$$d-dev $(LIBDIR)/libnetcdf_$$d.so.$(SO_VERSION) $(LIBDIR)/netcdf/$$d/libnetcdf.so ; \
		dh_link -p libnetcdf-$$d-dev $(LIBDIR)/libnetcdf_$$d.so.$(SO_VERSION) $(LIBDIR)/libnetcdf_$$d.so ; \
		dh_link -p libnetcdf-$$d-dev $(LIBDIR)/netcdf/$$d  $(LIBDIR)/netcdf/$$d/lib ;  \
		dh_link -p libnetcdf-$$d-dev  $(LIBDIR)/pkgconfig/netcdf-$$d.pc $(LIBDIR)/netcdf/$$d/pkgconfig/netcdf.pc ;\
		done

	# Strip RPATH
	-find $(CURDIR)/debian/tmp/usr/bin -type f -not -name nc-config -exec chrpath --delete {} \;
	-find $(CURDIR)/debian/tmp/usr/lib -type f -name "*.so*" -exec chrpath --delete {} \;
	cp include/netcdf_par.h debian/tmp/$(LIBDIR)/netcdf/mpi/include 

override_dh_auto_test:
	ARGS="--output-on-failure" dh_auto_test --max-parallel=1 || echo "Ignoring test failures"
	# Disable tests for pnetcdf. Multiple failures in nc_test where char conversions give:
	# test_put.c: NetCDF: Numeric conversion not representablea
	# This for 1.7.0pre1
	# LD_LIBRARY_PATH=$(CURDIR)/build-pnetcdf/liblib    $(MAKE) -C build-pnetcdf test

override_dh_installchangelogs:
	dh_installchangelogs RELEASE_NOTES.md

override_dh_strip:
	dh_strip --dbgsym-migration='netcdf-dbg (<< 1:4.5.0-2~)'

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION)
